#include <iostream>
#include <fstream>
#include <string>
#include "ChildProcess.h"

using namespace std;

const int BUFFER_SIZE = 128;

void ChildProcess::make_table()
{
    char buffer[BUFFER_SIZE];

    // Close the unused WRITE end of the pipe.
    close(fd[WRITE_FD]);

    // Write the start of the HTML page and table to stdout.
    cout << "<html>" << endl;
    cout << "<body>" << endl;
    cout << "<table border='1'>" << endl;
    cout << "    <tr>" << endl;
    cout << "        <th>Start</th><th>End</th>"
         << "<th>First</th><th>Middle</th><th>Last</th>" << endl;
    cout << "    </tr>" << endl;
    cout.flush();

    // Loop to read from the pipe.
    for (;;)
    {
        // Read pipe content into the buffer and write it to stdout.
        ssize_t size = read(fd[READ_FD], buffer, BUFFER_SIZE);
        cout.write(buffer, size);

        if (size < BUFFER_SIZE) break;
    }

    // Write the end of the HTML table and page to stdout.
    cout << "</table>" << endl;
    cout << "</body>" << endl;
    cout << "</html>" << endl;

    // Close the READ end of the pipe.
    close(fd[READ_FD]);
}
