#include <iostream>
#include <string>
#include "ParentProcess.h"

using namespace std;

const string TR_START = "    <tr>\n        ";
const string TR_END   = "\n    </tr>\n";

void ParentProcess::read_csv()
{
    string field;

    // Close the unused READ end of the pipe.
    close(fd[READ_FD]);

    // Loop to read the fields of each input line from stdin.
    while (getline(cin, field, ','))
    {
        // Write <tr> then the first field to the pipe.
        write(fd[WRITE_FD], TR_START.c_str(), TR_START.length());
        write_td(field);

        // Write subsequent fields up to the last field to the pipe.
        for (int i = 2; i < FIELD_COUNT; i++)
        {
            getline(cin, field, ',');
            write_td(field);
        }

        // Write the last field followed by </tr> to the pipe.
        getline(cin, field);
        write_td(field);
        write(fd[WRITE_FD], TR_END.c_str(), TR_START.length());
    }

    // Wait for the child process to finish.
    int status;
    waitpid(pid, &status, 0);

    // Close the WRITE end of the pipe.
    close(fd[WRITE_FD]);
}

void ParentProcess::write_td(string field)
{
    string td = "<td>" + field + "</td>";
    write(fd[WRITE_FD], td.c_str(), td.length());
}
